/* readsym.c - part of crash
 * Copyright (C) 2000 Tachibana Eriko
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

/****************************************************************
*	vAu						*
****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <a_out.h>
#include <sys/dos.h>
#include <sys/stat.h>
#include "crash.h"

#define HASHSIZE 101				/* nbVe[ũTCY */
#define STEPSIZE 128				/* jAe[ȗXebv */

struct sym {					/* m[h̍\ */
    struct sym *s_left;				/* m[hւ̃|C^ */
    struct sym *s_right;			/* Em[hւ̃|C^ */
    int s_address;				/* V{̈ʒuItZbg */
    const char s_name[0];			/* V{ */
};

/****************************************************************
*	ϐ							*
****************************************************************/

int binIndex;					/* jAe[ǔTCY */
int binAlloc;					/* jAe[ů蓖ăTCY */
int imageSize;					/* RAC[WTCY */
struct aouthdr aout;				/* st@Cwb_ */
struct corehdr core;				/* RAwb_ */
struct sym **binTable;				/* jAe[uւ̃|C^ */
struct sym *hashTable[HASHSIZE];		/* nbVe[u */
unsigned char *image;				/* RAC[W */

/****************************************************************
*	nbVlvZ					*
****************************************************************/

static int hash (const char *str)
{
    int ch, val;

    /* nbVlvZ */
    for (val = 0; (ch = *str) != 0; str++)
	val = (val << 1) ^ ch;

    /* 0 <= X < HASHSIZE ɂȂ悤Ɋۂ߂ */
    return val % HASHSIZE;
}

/****************************************************************
*	Vm[h蓖Ă				*
****************************************************************/

static struct sym *NewNode (const char *name)
{
    struct sym *node;

    /* jAe[uĂȂ? */
    if (binTable == 0) {

	/* ϐ */
	binIndex = 0;
	binAlloc = STEPSIZE;
	binTable = (struct sym **) malloc (sizeof (struct sym) * binAlloc);

	/* 蓖Ďs? */
	if (binTable == 0) {
	    Error ("܂");
	    exit (1);
	}

    }

    /* jAe[ułɈtɂȂĂ? */
    else if (binIndex >= binAlloc) {

	/* e[ũTCYg */
	binAlloc += STEPSIZE;
	binTable = (struct sym **)
	    realloc (binTable, sizeof (struct sym) * binAlloc);

	/* 蓖Ďs? */
	if (binTable == 0) {
	    Error ("܂");
	    exit (1);
	}

    }

    /* Vm[h蓖Ă */
    node = (struct sym *) malloc (sizeof (struct sym) + strlen (name) + 1);

    /* 蓖ăG[? */
    if (node == 0) {
	Error ("܂");
	exit (1);
    }

    /* jAe[uɓo^ */
    binTable[binIndex++] = node;

    /* m[hԂ */
    return node;
}

/****************************************************************
*	VV{o^				*
****************************************************************/

static void AddNode (int address, const char *name)
{
    int cmp;
    struct sym *node;
    struct sym **ptr;

    /* ؂nbVe[uI */
    ptr = &hashTable[hash (name)];

    /* ؂w肵V{̃m[hT */
    for (;;) {

	/* m[h݂Ȃ? */
	if (*ptr == 0) {

	    /* Vm[hmۂ */
	    node = NewNode (name);

	    /* m[hf[^ݒ */
	    node->s_left = 0;
	    node->s_right = 0;
	    node->s_address = address;
	    strcpy ((char *) node->s_name, name);

	    /* m[ho^ */
	    *ptr = node;

	    /* verbose bZ[W\ */
	    VERBOSE (10, printf ("0x%06x - V{ '%s'\n", address, name));

	    /* I */
	    return;

	}

	/* V{r */
	if ((cmp = strcmp (name, (*ptr)->s_name)) == 0)
	    return;

	/* ̃m[h̃AhX𓾂 */
	ptr = (cmp < 0) ? &(*ptr)->s_left : &(*ptr)->s_right;

    }
}

/****************************************************************
*	V{Ōs					*
****************************************************************/

void *SearchByName (const char *name)
{
    int cmp;
    struct sym *ptr;

    /* ؂nbVe[uI */
    ptr = hashTable[hash (name)];

    /* ؂w肵V{̃m[hT */
    while (ptr) {

	/* V{r */
	if ((cmp = strcmp (name, ptr->s_name)) == 0)
	    return (void *) (image + ptr->s_address + 256);

	/* ̃m[h̃AhX𓾂 */
	ptr = (cmp < 0) ? ptr->s_left : ptr->s_right;

    }

    /* Ȃ */
    Warning ("V{ '%s' `Ă܂");
    return 0;
}

/****************************************************************
*	AhXŌs					*
****************************************************************/

char *SearchByAddress (int address)
{
    int left;
    int right;
    int middle;
    int offset;
    struct sym *near;
    static char buffer[256];

    /* vZẌO? */
    if (address < core.psta || address > core.last)
	strcpy (buffer, "vZẌO");

    /* q[v̈悩? */
    else if (address >= core.hsta)
	sprintf (buffer, "q[v̈ (+0x%lx)", address - core.hsta);

    /* LX^bN̈悩? */
    else if (address >= core.sp)
	sprintf (buffer, "X^bN̈ (-0x%lx)", core.hsta - address);

    /* X^bN̈悩? */
    else if (address >= core.ssta)
	sprintf (buffer, "gpX^bN̈ (-0x%lx)", core.hsta - address);

    /* ϐ̈悩? */
    else if (address >= core.esta)
	sprintf (buffer, "̈ (+0x%lx)", address - core.esta);

    /* VXe\̈悩? */
    else if (address >= core.csta)
	sprintf (buffer, "\̈ (+0x%lx)", address - core.csta);

    /* ȊO */
    else {

	/* AhXItZbgɕϊ */
	address -= core.psta;

	/* ϐ */
	left = 0;
	right = binIndex + 1;

	/* jAe[u 2 T */
	while (left < right) {

	    /* 2 _vZ */
	    middle = (left + right) >> 1;

	    /* rɂ L,R ǂ炩I */
	    if (binTable[middle]->s_address <= address)
		left = middle + 1;
	    else
		right = middle;

	}

	/* O̍ŋ߃V{𓾂 */
	near = binTable[left - 1];

	/* O̍ŋ߃V{Ƃ̃ItZbgvZ */
	offset = address - near->s_address;

	/* 𐶐 */
	if (offset == 0)
	    sprintf (buffer, "%s (+0x%x)", near->s_name, address);
	else
	    sprintf (buffer, "%s+%d (+0x%x)", near->s_name, offset, address);

    }

    /* buffer Ԃ */
    return buffer;
}

/****************************************************************
*	\[gpAhXr[`				*
****************************************************************/

static int compareAddress (const void *pa, const void *pb)
{
    const struct sym **ppa = (const struct sym **) pa;
    const struct sym **ppb = (const struct sym **) pb;

    /* AhX̒lŔr */
    return (*ppa)->s_address - (*ppb)->s_address;
}

/****************************************************************
*	wt@CV{ǂ݁Ae[u쐬		*
****************************************************************/

void ReadSymbols (const char *fname)
{
    FILE *fp;
    int ch, type, address;
    int index, last;
    char name[256];

    /* st@CI[v */
    if ((fp = fopen (fname, "rb")) == 0) {
	Error ("st@C '%s' ܂", fname);
	exit (1);
    }

    /* st@C̃wb_ǂݍ */
    if (fread (&aout, sizeof (aout), 1, fp) != 1) {
	Error ("st@C '%s' ̃wb_ǂݍ݂Ɏs܂", fname);
	exit (1);
    }

    /* st@Cǂ`FbN */
    if (aout.magic != XMAGIC) {
	Error ("'%s' ͎st@Cł͂܂", fname);
	exit (1);
    }

    /* V{e[üʒu܂ŃV[N */
    if (aout.symbol == 0 || fseek (fp, N_SYMOFF (aout), SEEK_CUR) < 0) {
	Error ("'%s' ɂ̓V{e[u܂", fname);
	exit (1);
    }

    /* V{e[u̍ŏIʒuL^ */
    last = ftell (fp) + aout.symbol;

    /* verbose bZ[W */
    VERBOSE (1, printf ("V{ǂݍݒ...\n"));

    /* iv[v */
    for (;;) {

	/* V{^Cv (2byte) 擾 */
	type = (fgetc (fp) << 8) | fgetc (fp);

	/* V{̃ItZbgʒu (4byte) 擾 */
	address = getw (fp);

	/* V{擾 */
	for (index = 0; (ch = fgetc (fp)) != 0 && ch != EOF; index++)
	    name[index] = ch;

	/* ɏI[L */
	name[index] = '\0';

	/* ACg */
	if ((index & 1) == 0)
	    (void) fgetc (fp);

	/* 擾V{e[uɓo^ */
	AddNode (address, name);

	/* I肩? */
	if (ftell (fp) >= last)
	    break;

    }

    /* verbose bZ[W */
    VERBOSE (1, printf ("V{\[gł...\n"));

    /* jAe[u\[g */
    qsort (binTable, binIndex, sizeof (struct sym *), compareAddress);

    /* close file */
    fclose (fp);
}

/* Functions */
void ReadCore (const char *fname)
{
    FILE *fp;
    struct stat st;

    /* RAt@CI[v */
    if ((fp = fopen (fname, "rb")) == 0) {
	Error ("RAt@C '%s' ܂", fname);
	exit (1);
    }

    /* verbose bZ[W */
    VERBOSE (1, printf ("RAC[Wǂݍݒ...\n"));

    /* RAwb_ǂݍ */
    if (fread (&core, sizeof (core), 1, fp) != 1) {
	Error ("RAt@C '%s' ̃wb_ǂݍ݂Ɏs܂", fname);
	exit (1);
    }

    /* ǂݍރf[^̃TCYvZ */
    stat (fname, &st);
    imageSize = st.st_size - sizeof (core);

    /* RAC[Wǂݍރobt@mۂ */
    if ((image = (unsigned char *) malloc (imageSize)) == 0) {
	Error ("܂");
	exit (1);
    }

    /* RAC[Wǂݍ */
    if (fread (image, 1, imageSize, fp) != imageSize) {
	Error ("RAC[W̓ǂݍ݂Ɏs܂");
	exit (1);
    }

    /* close file */
    fclose (fp);
}
