/* rl.h - ReadLine() header
 * Copyright (C) 2000 Tachibana Eriko
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef	__rl_h__
#define	__rl_h__

#ifndef __GNUC__
#error You lose. This file can be compiled only by GNU-C compiler.
#endif

#include <cdecl.h>
#include <stddef.h>


typedef struct {
  unsigned char* buf;
  int_ size;
  unsigned char* yank_buf;
  unsigned const char* words;
  void (*null) (void);
  void (*bell) (void);
  int_ (*complete) (unsigned char* buf, unsigned const char** top_ptr, int_* len_ptr,
		    unsigned char* list_buf, int_ list_buf_len);
  void* (*malloc) (size_t size);
  void (*mfree) (void* ptr);
  int_ csr_x;
  int_ mark_x;
  int_ margin;
  int_ width;
  short win_x;
  short win_y;

  unsigned char col;
  unsigned char c_col;
  unsigned char c_atr;
  unsigned char c_slash;
  unsigned char c_adds;
  unsigned char c_disp;

  unsigned char f_dot;
  unsigned char f_emacs;
  unsigned char f_fep;
  unsigned char f_up;
  unsigned char f_down;
  unsigned char f_ru;
  unsigned char f_rd;
} RL;

_EXTERN (int_ ReadLine (RL* rl));

#endif	/* !__rl_h__ */

/* EOF */
